package com.zipcodewilmington;

import com.sun.xml.internal.fastinfoset.util.StringArray;

import java.util.ArrayList;
import java.util.Arrays;

/**
 * Created by leon on 1/29/18.
 */
public class StringArrayUtils {
    /**
     * @param array array of String objects
     * @return first element of specified array
     */ // TODO
    public static String getFirstElement(String[] array) {
        return array[0];
    }

    /**
     * @param array array of String objects
     * @return second element in specified array
     */
    public static String getSecondElement(String[] array) {
        return array[1];
    }

    /**
     * @param array array of String objects
     * @return last element in specified array
     */ // TODO
    public static String getLastElement(String[] array) {
        return array[array.length - 1];
    }

    /**
     * @param array array of String objects
     * @return second to last element in specified array
     */ // TODO
    public static String getSecondToLastElement(String[] array) {
        return array[array.length - 2];
    }

    /**
     * @param array array of String objects
     * @param value value to check array for
     * @return true if the array contains the specified `value`
     */ // TODO
    public static boolean contains(String[] array, String value) {
        boolean contains = false;
        for (String s: array) {
            if (s.equals(value)){
                contains = true;
            }
        }
        return contains;
    }

    /**
     * @param array of String objects
     * @return an array with identical contents in reverse order
     */ // TODO
    public static String[] reverse(String[] array) {
        String[] strArrReversed = new String[array.length];
        int x = 0;
        for (int i = array.length - 1; i >= 0; i--){
            strArrReversed[x] = (array[i]);
            x++;
        }

        return strArrReversed;
    }

    /**
     * @param array array of String objects
     * @return true if the order of the array is the same backwards and forwards
     */ // TODO
    public static boolean isPalindromic(String[] array) {
        boolean isAPalindrom = true;
        int countRev = array.length - 1;
        for (int countUp = 0; countUp < array.length; countUp++){
            if (array[countUp].equals(array[countRev]) == false){
                isAPalindrom = false;
            }
            countRev--;
        }
        return isAPalindrom;
    }

    /**
     * @param array array of String objects
     * @return true if each letter in the alphabet has been used in the array
     */ // TODO
    public static boolean isPangramic(String[] array) {
        boolean isAPanGramic = true;
        String strLower = "";
    //Array - toLowerCase - Concat
        for (String var : array) {
            strLower = strLower.concat(var.toLowerCase());
        }
    //loop through ANSI lower case values a-z
        // IF! contains - boolean set to false
        for(int i = 97; i <= 122; i++){
            if(!strLower.contains(Character.toString((char)i))){
                isAPanGramic = false;
            }
        }
        return isAPanGramic;
    }

    /**
     * @param array array of String objects
     * @param value value to check array for
     * @return number of occurrences the specified `value` has occurred
     */ // TODO
    public static int getNumberOfOccurrences(String[] array, String value) {
        int count = 0;
        for (String arrayVar: array) {
            if (arrayVar.equals(value)){
                count++;
            }
        }
        return count;
    }

    /**
     * @param array         array of String objects
     * @param valueToRemove value to remove from array
     * @return array with identical contents excluding values of `value`
     */ // TODO
    public static String[] removeValue(String[] array, String valueToRemove) {
        ArrayList<String> arrayList = new ArrayList<String>();
        for (int i = 0; i < array.length; i++) {
            if(!array[i].equals(valueToRemove)) {
                arrayList.add(array[i]);
            }
        }
        String[] strReturn = arrayList.toArray(new String[arrayList.size()]);

        return strReturn;
    }

    /**
     * @param array array of chars
     * @return array of Strings with consecutive duplicates removes
     */ // TODO
    public static String[] removeConsecutiveDuplicates(String[] array) {
        ArrayList<String> arrayList = new ArrayList<String>();
        arrayList.add(array[0]);
        for (int i = 0; i < array.length - 1; i++) {
            if (!array[i].equals(array[i+1])) {
                arrayList.add(array[i+1]);
            }
        }
        String[] strReturn = arrayList.toArray(new String[arrayList.size()]);

        return strReturn;
    }

    /**
     * @param array array of chars
     * @return array of Strings with each consecutive duplicate occurrence concatenated as a single string in an array of Strings
     */ // TODO
    public static String[] packConsecutiveDuplicates(String[] array) {
        ArrayList<String> arrayList = new ArrayList<String>();
        arrayList.add(array[0]);
        for(int i = 1; i < array.length; i++)
        {
            if(array[i].equals(array[i-1]))
            {
                String str = arrayList.get(arrayList.size() - 1).concat(array[i]);
                arrayList.set(arrayList.size() - 1, str);
            }
            else
            {
                arrayList.add(array[i]);
            }
        }
        String[] strReturn = arrayList.toArray(new String[arrayList.size()]);
        return strReturn;
    }


}
